## [Getting the Source](#source)
## [Quick Start](#quick-start)
* [Making a map](#quick.map)
* [Moving around](#quick.moving)
* [Working with layers](#quick.layers)

## [Map](#Map)
* [getCenter](#Map.getCenter)
* [setCenter](#Map.setCenter)
* [getZoom](#Map.getZoom)
* [setZoom](#Map.setZoom)
* [setCenterZoom](#Map.setCenterZoom)
* [getExtent](#Map.getExtent)
* [setExtent](#Map.setExtent)
* [zoomIn](#Map.zoomIn)
* [zoomOut](#Map.zoomOut)
* [zoomBy](#Map.zoomBy)
* [zoomByAbout](#Map.zoomByAbout)
* [panBy](#Map.panBy)
* [panLeft](#Map.panLeft)
* [panRight](#Map.panRight)
* [panUp](#Map.panUp)
* [panDown](#Map.panDown)
* [center](#Map.center)
* [zoom](#Map.zoom)
* [extent](#Map.extent)
* [addLayer](#Map.addLayer)
* [removeLayer](#Map.removeLayer)
* [getLayers](#Map.getLayers)
* [getLayerAt](#Map.getLayerAt)
* [setLayerAt](#Map.setLayerAt)
* [insertLayerAt](#Map.insertLayerAt)
* [removeLayerAt](#Map.removeLayerAt)
* [swapLayersAt](#Map.swapLayersAt)
* [addCallback](#Map.addCallback)
* [removeCallback](#Map.removeCallback)
* [pointLocation](#Map.pointLocation)
* [pointCoordinate](#Map.pointCoordinate)
* [locationPoint](#Map.locationPoint)
* [locationCoordinate](#Map.locationCoordinate)
* [coordinateLocation](#Map.coordinateLocation)
* [coordinatePoint](#Map.coordinatePoint)
* [setZoomRange](#Map.setZoomRange)
* [setSize](#Map.setSize)
* [autoSize](#Map.autoSize)
* [dimensions](#Map.dimensions)
* [draw](#Map.draw)
* [requestRedraw](#Map.requestRedraw)
* [parent](#Map.parent)
* [coordinate](#Map.coordinate)
* [coordLimits](#Map.coordLimits)
* [tileSize](#Map.tileSize)

## [Location](#Location)
* [latitude](#Location.lat) and [longitude](#Location.lon)
* [Location.fromString](#Location.fromString)
* [Location.distance](#Location.fromString)
* [Location.interpolate](#Location.fromString)
* [Location.bearing](#Location.fromString)

## [Extent](#Extent)
* [north](#Extent.north), [east](#Extent.east), [south](#Extent.south) and [west](#Extent.west)
* [northWest](#Extent.northWest)
* [northEast](#Extent.northEast)
* [southEast](#Extent.southEast)
* [southWest](#Extent.southWest)
* [containsLocation](#Extent.containsLocation)
* [encloseLocation](#Extent.encloseLocation)
* [encloseLocations](#Extent.encloseLocations)
* [encloseExtent](#Extent.encloseExtent)
* [setFromLocations](#Extent.setFromLocations)
* [copy](#Extent.copy)
* [toArray](#Extent.toArray)
* [Extent.fromString](#Extent.fromString)
* [Extent.fromArray](#Extent.fromArray)

## [Point](#Point)
* [Point.distance](#Point.distance)
* [Point.interpolate](#Point.interpolate)

## [Coordinate](#Coordinate)
* [zoom](#Coordinate.zoom), [column](#Coordinate.column) and [row](#Coordinate.row)
* [zoomTo](#Coordinate.zoomTo)
* [zoomBy](#Coordinate.zoomBy)
* [container](#Coordinate.container)
* [up](#Coordinate.up)
* [down](#Coordinate.down)
* [left](#Coordinate.left)
* [right](#Coordinate.right)
* [toKey](#Coordinate.toKey)
* [toString](#Coordinate.toString)

## [TemplatedLayer](#TemplatedLayer)

## [Layer](#Layer)
* [getProvider](#Layer.getProvider)
* [setProvider](#Layer.setProvider)
* [draw](#Layer.draw)
* [requestRedraw](#Layer.requestRedraw)

## [Template](#Template)

## [MapProvider](#MapProvider)
* [getTile](#MapProvider.getTile)
* [getTileUrl](#MapProvider.getTileUrl)
* [releaseTile](#MapProvider.releaseTile)
* [reAddTile](#MapProvider.reAddTile)

