/*
 * IDBWrapper - A cross-browser wrapper for IndexedDB
 * Copyright (c) 2011 - 2013 Jens Arps
 * http://jensarps.de/
 *
 * Licensed under the MIT (X11) license
 */
(function(h,g,e){"function"===typeof define?define(g):"undefined"!==typeof module&&module.exports?module.exports=g():e[h]=g()})("IDBStore",function(){var h,g={storeName:"Store",dbVersion:1,keyPath:"id",autoIncrement:!0,onStoreReady:function(){},onError:function(a){throw a;},indexes:[]};h=function(a,c){for(var b in g)this[b]="undefined"!=typeof a[b]?a[b]:g[b];this.dbName="IDBWrapper-"+this.storeName;this.dbVersion=parseInt(this.dbVersion,10);c&&(this.onStoreReady=c);this.idb=window.indexedDB||window.webkitIndexedDB||
window.mozIndexedDB;this.keyRange=window.IDBKeyRange||window.webkitIDBKeyRange||window.mozIDBKeyRange;this.consts={READ_ONLY:"readonly",READ_WRITE:"readwrite",VERSION_CHANGE:"versionchange",NEXT:"next",NEXT_NO_DUPLICATE:"nextunique",PREV:"prev",PREV_NO_DUPLICATE:"prevunique"};this.openDB()};h.prototype={version:"0.3.1",db:null,dbName:null,dbVersion:null,store:null,storeName:null,keyPath:null,autoIncrement:null,indexes:null,features:null,onStoreReady:null,onError:null,_insertIdCount:0,openDB:function(){(this.features=
{}).hasAutoIncrement=!window.mozIndexedDB;var a=this.idb.open(this.dbName,this.dbVersion),c=!1;a.onerror=function(a){var c=!1;"error"in a.target?c="VersionError"==a.target.error.name:"errorCode"in a.target&&(c=12==a.target.errorCode);if(c)this.onError(Error("The version number provided is lower than the existing one."));else this.onError(a)}.bind(this);a.onsuccess=function(a){if(!c)if(this.db)this.onStoreReady();else if(this.db=a.target.result,"string"==typeof this.db.version)this.onError(Error("The IndexedDB implementation in this browser is outdated. Please upgrade your browser."));
else if(this.db.objectStoreNames.contains(this.storeName))this.store=this.db.transaction([this.storeName],this.consts.READ_ONLY).objectStore(this.storeName),this.indexes.forEach(function(a){var b=a.name;if(b)if(this.normalizeIndexData(a),this.hasIndex(b)){var f=this.store.index(b);this.indexComplies(f,a)||(c=!0,this.onError(Error('Cannot modify index "'+b+'" for current version. Please bump version number to '+(this.dbVersion+1)+".")))}else c=!0,this.onError(Error('Cannot create new index "'+b+'" for current version. Please bump version number to '+
(this.dbVersion+1)+"."));else c=!0,this.onError(Error("Cannot create index: No index name given."))},this),c||this.onStoreReady();else this.onError(Error("Something is wrong with the IndexedDB implementation in this browser. Please upgrade your browser."))}.bind(this);a.onupgradeneeded=function(a){this.db=a.target.result;this.store=this.db.objectStoreNames.contains(this.storeName)?a.target.transaction.objectStore(this.storeName):this.db.createObjectStore(this.storeName,{keyPath:this.keyPath,autoIncrement:this.autoIncrement});
this.indexes.forEach(function(a){var b=a.name;b||(c=!0,this.onError(Error("Cannot create index: No index name given.")));this.normalizeIndexData(a);if(this.hasIndex(b)){var f=this.store.index(b);this.indexComplies(f,a)||(this.store.deleteIndex(b),this.store.createIndex(b,a.keyPath,{unique:a.unique,multiEntry:a.multiEntry}))}else this.store.createIndex(b,a.keyPath,{unique:a.unique,multiEntry:a.multiEntry})},this)}.bind(this)},deleteDatabase:function(){this.idb.deleteDatabase&&this.idb.deleteDatabase(this.dbName)},
put:function(a,c,b){b||(b=function(a){console.error("Could not write data.",a)});c||(c=e);"undefined"==typeof a[this.keyPath]&&!this.features.hasAutoIncrement&&(a[this.keyPath]=this._getUID());a=this.db.transaction([this.storeName],this.consts.READ_WRITE).objectStore(this.storeName).put(a);a.onsuccess=function(a){c(a.target.result)};a.onerror=b},get:function(a,c,b){b||(b=function(a){console.error("Could not read data.",a)});c||(c=e);a=this.db.transaction([this.storeName],this.consts.READ_ONLY).objectStore(this.storeName).get(a);
a.onsuccess=function(a){c(a.target.result)};a.onerror=b},remove:function(a,c,b){b||(b=function(a){console.error("Could not remove data.",a)});c||(c=e);a=this.db.transaction([this.storeName],this.consts.READ_WRITE).objectStore(this.storeName)["delete"](a);a.onsuccess=function(a){c(a.target.result)};a.onerror=b},batch:function(a,c,b){b||(b=function(a){console.error("Could not apply batch.",a)});c||(c=e);var d=this.db.transaction([this.storeName],this.consts.READ_WRITE),j=a.length,f=!1;a.forEach(function(a){var e=
a.type,h=a.key,g=a.value;"remove"==e?(a=d.objectStore(this.storeName)["delete"](h),a.onsuccess=function(){j--;0==j&&!f&&(f=!0,c())},a.onerror=function(a){d.abort();f||(f=!0,b(a,e,h))}):"put"==e&&("undefined"==typeof g[this.keyPath]&&!this.features.hasAutoIncrement&&(g[this.keyPath]=this._getUID()),a=d.objectStore(this.storeName).put(g),a.onsuccess=function(){j--;0==j&&!f&&(f=!0,c())},a.onerror=function(a){d.abort();f||(f=!0,b(a,e,g))})},this)},getAll:function(a,c){c||(c=function(a){console.error("Could not read data.",
a)});a||(a=e);var b=this.db.transaction([this.storeName],this.consts.READ_ONLY),d=b.objectStore(this.storeName);d.getAll?(b=d.getAll(),b.onsuccess=function(c){a(c.target.result)},b.onerror=c):this._getAllCursor(b,a,c)},_getAllCursor:function(a,c,b){var d=[];a=a.objectStore(this.storeName).openCursor();a.onsuccess=function(a){(a=a.target.result)?(d.push(a.value),a["continue"]()):c(d)};a.onError=b},clear:function(a,c){c||(c=function(a){console.error("Could not clear store.",a)});a||(a=e);var b=this.db.transaction([this.storeName],
this.consts.READ_WRITE).objectStore(this.storeName).clear();b.onsuccess=function(c){a(c.target.result)};b.onerror=c},_getUID:function(){return this._insertIdCount++ +Date.now()},getIndexList:function(){return this.store.indexNames},hasIndex:function(a){return this.store.indexNames.contains(a)},normalizeIndexData:function(a){a.keyPath=a.keyPath||a.name;a.unique=!!a.unique;a.multiEntry=!!a.multiEntry},indexComplies:function(a,c){return["keyPath","unique","multiEntry"].every(function(b){return"multiEntry"==
b&&void 0===a[b]&&!1===c[b]?!0:c[b]==a[b]})},iterate:function(a,c){c=k({index:null,order:"ASC",filterDuplicates:!1,keyRange:null,writeAccess:!1,onEnd:null,onError:function(a){console.error("Could not open cursor.",a)}},c||{});var b="desc"==c.order.toLowerCase()?"PREV":"NEXT";c.filterDuplicates&&(b+="_NO_DUPLICATE");var d=this.db.transaction([this.storeName],this.consts[c.writeAccess?"READ_WRITE":"READ_ONLY"]),j=d.objectStore(this.storeName);c.index&&(j=j.index(c.index));b=j.openCursor(c.keyRange,
this.consts[b]);b.onerror=c.onError;b.onsuccess=function(b){if(b=b.target.result)a(b.value,b,d),b["continue"]();else if(c.onEnd)c.onEnd();else a(null)}},count:function(a,c){c=k({index:null,keyRange:null},c||{});var b=c.onError||function(a){console.error("Could not open cursor.",a)},d=this.db.transaction([this.storeName],this.consts.READ_ONLY).objectStore(this.storeName);c.index&&(d=d.index(c.index));d=d.count(c.keyRange);d.onsuccess=function(b){a(b.target.result)};d.onError=function(a){b(a)}},makeKeyRange:function(a){var c=
"undefined"!=typeof a.lower,b="undefined"!=typeof a.upper;switch(!0){case c&&b:a=this.keyRange.bound(a.lower,a.upper,a.excludeLower,a.excludeUpper);break;case c:a=this.keyRange.lowerBound(a.lower,a.excludeLower);break;case b:a=this.keyRange.upperBound(a.upper,a.excludeUpper);break;default:throw Error('Cannot create KeyRange. Provide one or both of "lower" or "upper" value.');}return a}};var e=function(){},l={},k=function(a,c){var b,d;for(b in c)d=c[b],d!==l[b]&&d!==a[b]&&(a[b]=d);return a};h.version=
h.prototype.version;return h},this);
